﻿#region Copyright Syncfusion Inc. 2001 - 2010
//
//  Copyright Syncfusion Inc. 2001 - 2010. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections;
using System.Drawing;

namespace Syncfusion.GridHelperClasses
{
	/// <summary>
	/// Summary description for RtfColorTable.
	/// </summary>
	public class RtfColorTable
	{
		private int numberOfColors = 0;
		private string colortbl;
		private Hashtable loadedColors = new Hashtable();

		public RtfColorTable()
		{
			//
			// TODO: Add constructor logic here
			//
			colortbl = "{\\colortbl;";
		}

		public int UseColor(Color key)
		{
			if (loadedColors.ContainsKey(key))
			{
				return (int)loadedColors[key];
			}
			else
			{
				colortbl += "\\red" + key.R + "\\green" + key.G + "\\blue" + key.B + ";";
				loadedColors.Add(key, ++numberOfColors);
				return numberOfColors;
			}
		}

		public override string ToString()
		{
			return colortbl + "}";
		}
	}
}
