﻿#region Copyright Syncfusion Inc. 2001 - 2010
//
//  Copyright Syncfusion Inc. 2001 - 2010. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;

namespace Syncfusion.GridHelperClasses
{
	/// <summary>
	/// Summary description for RtfDocument.
	/// </summary>
	public class RtfDocument
	{
		private RtfFontTable fonttbl;
		private RtfColorTable colortbl;
		private string header;
		private string document;

		public RtfDocument()
		{
			//
			// TODO: Add constructor logic here
			//
			header = "{\\rtf1";
			fonttbl = new RtfFontTable();
			colortbl = new RtfColorTable();
		}

		public override string ToString()
		{
			header += fonttbl.ToString() + colortbl.ToString();
			return header + "{" + document + "}}";
		}

		public void AppendText(string text)
		{
			document += text;
		}

		public int UseFont(string fontName)
		{
			return fonttbl.UseFont(fontName);
		}

		public int UseColor(Color fromArgb)
		{
			return colortbl.UseColor(fromArgb);
		}
	}
}
