#region Copyright Syncfusion Inc. 2001 - 2009
// Copyright Syncfusion Inc. 2001 - 2009. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Grouping;

namespace Syncfusion.GridHelperClasses
{
    /// <summary>
    /// Summary description for CustomRowFilter.
    /// </summary>
    internal class CustomRowFilter : Syncfusion.Windows.Forms.Office2007Form
    {
        private Syncfusion.Windows.Forms.Tools.ComboBoxAdv comboBox1;
        private Syncfusion.Windows.Forms.Tools.ComboBoxAdv comboBox2;
        private System.Windows.Forms.Panel panel1;
        private Syncfusion.Windows.Forms.Tools.RadioButtonAdv radioButton1;
        private Syncfusion.Windows.Forms.Tools.RadioButtonAdv radioButton2;
        private Syncfusion.Windows.Forms.ButtonAdv button1;
        private Syncfusion.Windows.Forms.ButtonAdv button2;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        internal string compareText1, compareText2;
        private Syncfusion.Windows.Forms.Tools.ComboBoxAdv compareList1;
        private Syncfusion.Windows.Forms.Tools.ComboBoxAdv compareList2;
        private IContainer components;
        private object[] uniqueList;
        private string styles;

        public CustomRowFilter(string styles)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.comboBox1.DataSource = GetComboTable();
            this.comboBox1.DisplayMember = "FilterString";
            this.comboBox1.ValueMember = "ValueString";
            this.comboBox2.DataSource = GetComboTable();
            this.comboBox2.DisplayMember = "FilterString";
            this.comboBox2.ValueMember = "ValueString";
            this.styles = styles;
        }

        public CustomRowFilter(string styles, object[] uniqueList)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.comboBox1.DataSource = GetComboTable();
            this.comboBox1.DisplayMember = "FilterString";
            this.comboBox1.ValueMember = "ValueString";
            this.comboBox2.DataSource = GetComboTable();
            this.comboBox2.DisplayMember = "FilterString";
            this.comboBox2.ValueMember = "ValueString";
            this.styles = styles;
            this.uniqueList = uniqueList;
            this.compareList1.DataSource = uniqueList;
            this.compareList2.DataSource = uniqueList.Clone();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.comboBox1 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            this.comboBox2 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            this.panel1 = new System.Windows.Forms.Panel();
            this.radioButton2 = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.radioButton1 = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.button1 = new Syncfusion.Windows.Forms.ButtonAdv();
            this.button2 = new Syncfusion.Windows.Forms.ButtonAdv();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.compareList1 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            this.compareList2 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox2)).BeginInit();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareList1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareList2)).BeginInit();
            this.SuspendLayout();
            // 
            // comboBox1
            // 
            this.comboBox1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox1.Location = new System.Drawing.Point(24, 64);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(216, 21);
            this.comboBox1.TabIndex = 1;
            // 
            // comboBox2
            // 
            this.comboBox2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox2.Location = new System.Drawing.Point(24, 136);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(216, 21);
            this.comboBox2.TabIndex = 2;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.radioButton2);
            this.panel1.Controls.Add(this.radioButton1);
            this.panel1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.panel1.Location = new System.Drawing.Point(24, 96);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(216, 32);
            this.panel1.TabIndex = 4;
            // 
            // radioButton2
            // 
            this.radioButton2.Checked = true;
            this.radioButton2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton2.Location = new System.Drawing.Point(120, 8);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(48, 16);
            this.radioButton2.TabIndex = 1;
            this.radioButton2.TabStop = true;
            this.radioButton2.Text = SR.GetString(SR.Office2007FilterCustomFilteror);
            // 
            // radioButton1
            // 
            this.radioButton1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton1.Location = new System.Drawing.Point(56, 8);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(48, 16);
            this.radioButton1.TabIndex = 0;
            this.radioButton1.Text = SR.GetString(SR.Office2007FilterCustomFilterand);
            // 
            // button1
            // 
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Standard;
            this.button1.Font = new System.Drawing.Font("Segoe UI", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button1.Location = new System.Drawing.Point(304, 176);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(72, 24);
            this.button1.TabIndex = 5;
            this.button1.Text = SR.GetString(SR.CustomAutoFilterOK);
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Standard;
            this.button2.Font = new System.Drawing.Font("Segoe UI", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button2.Location = new System.Drawing.Point(392, 176);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(72, 24);
            this.button2.TabIndex = 6;
            this.button2.Text = SR.GetString(SR.CustomAutoFilterCancel);
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(24, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(448, 16);
            this.label1.TabIndex = 7;
            this.label1.Text = SR.GetString(SR.showstherowswhere);
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(24, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(216, 16);
            this.label2.TabIndex = 8;
            // 
            // compareList1
            // 
            this.compareList1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.compareList1.Location = new System.Drawing.Point(256, 64);
            this.compareList1.Name = "compareList1";
            this.compareList1.Size = new System.Drawing.Size(216, 21);
            this.compareList1.TabIndex = 9;
            this.compareList1.TextChanged += new EventHandler(compareList1_TextChanged);
            // 
            // compareList2
            // 
            this.compareList2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.compareList2.Location = new System.Drawing.Point(256, 136);
            this.compareList2.Name = "compareList2";
            this.compareList2.Size = new System.Drawing.Size(216, 21);
            this.compareList2.TabIndex = 10;
            this.compareList2.TextChanged += new EventHandler(compareList1_TextChanged);
            // 
            // CustomRowFilter
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
            this.ClientSize = new System.Drawing.Size(490, 208);
            this.Controls.Add(this.compareList2);
            this.Controls.Add(this.compareList1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.comboBox2);
            this.Controls.Add(this.comboBox1);
            this.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "CustomRowFilter";
            this.Text = SR.GetString(SR.CustomAutoFilterDialogBox);
            this.Load += new System.EventHandler(this.CustomRowFilter_Load);
            ((System.ComponentModel.ISupportInitialize)(this.comboBox1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox2)).EndInit();
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.radioButton2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareList1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareList2)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
            if (this.comboBox1.Text.Length > 0 && this.compareList1.Text.Length > 0)
            {
                FilterString = '[' + mappingName + ']' + GetFilter(this.comboBox1.SelectedIndex, this.compareList1.Text);
            }
            if (this.comboBox2.Text.Length > 0 && this.compareList2.Text.Length > 0)
            {
                FilterString += (this.radioButton1.Checked) ? " AND " : " OR ";
                FilterString += '[' + mappingName + ']' + GetFilter(this.comboBox2.SelectedIndex, this.compareList2.Text);
            }
            compareText1 = this.compareList1.Text;
            compareText2 = this.compareList2.Text;
            this.DialogResult = DialogResult.OK;
            this.Close();
		}

        public void SetCombo(int index)
        {
            switch (index)
            {
                case 0:
                case 7:
                    this.comboBox1.SelectedIndex = 0;
                    break;
                case 1:
                    this.comboBox1.SelectedIndex = 1;
                    break;
                case 2:
                case 3:
                    this.comboBox1.SelectedIndex = 8;
                    break;
                case 4:
                    this.comboBox1.SelectedIndex = 9;
                    break;
                case 5:
                    this.comboBox1.SelectedIndex = 7;
                    break;                
            }            
            this.comboBox2.Text = String.Empty;
        }

        private string GetFilter(int index, string text)
        {
            string s = "";
            switch (index)
            {
                case 0:
                    s = " = '" + text + "'";
                    break;
                case 1:
                    s = " <> '" + text + "'";
                    break;
                case 2:
                    s = " > '" + text + "'";
                    break;
                case 3:
                    s = " >= '" + text + "'";
                    break;
                case 4:
                    s = " < '" + text + "'";
                    break;
                case 5:
                    s = " <= '" + text + "'";
                    break;
                case 6:
                    s = " like '" + text + "'";
                    break;
                case 7:
                    s = " like '*" + text + "*'";
                    break;
                case 8:
                    s = " like '" + text + "*'";
                    break;
                case 9:
                    s = " like '*" + text + "'";
                    break;
            }
            return s;
        }


		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
        void compareList1_TextChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(this.compareList1.Text) || !string.IsNullOrEmpty(this.compareList2.Text))
                this.button1.Enabled = true;
            else
                this.button1.Enabled = false;
        }

		public string columnName = string.Empty;
        public string mappingName = String.Empty;
        public string FilterString = string.Empty;	
 
 
		private void CustomRowFilter_Load(object sender, System.EventArgs e)
		{            
			this.label2.Text = columnName;
            compareList1.Text = string.Empty;
            compareList2.Text = string.Empty;

            this.StartPosition = FormStartPosition.CenterScreen;
            this.button1.UseVisualStyle = true;
            this.button2.UseVisualStyle = true;
            this.UseOffice2007SchemeBackColor = true;
            this.label1.BackColor = Color.Transparent;
            this.label2.BackColor = Color.Transparent;
            this.button1.BackColor = Color.Transparent;
            this.button2.BackColor = Color.Transparent;
            this.panel1.BackColor = Color.Transparent;
            this.button1.Enabled = false;
            switch (this.styles)
            {
                case "SystemTheme":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.None;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.None;
                    break;
                case "Metro":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.Metro;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.Metro;
                    break;
                case "Custom":
                    this.button1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Managed;
                    this.button2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Managed;
                    break;
                case "Office2003":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.Office2003;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.Office2003;
                    this.button1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.button2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.comboBox1.Style = Windows.Forms.VisualStyle.Office2003;
                    this.comboBox2.Style = Windows.Forms.VisualStyle.Office2003;
                    this.comboBox1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.comboBox2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.radioButton1.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton2.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.radioButton2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.compareList1.Style = Windows.Forms.VisualStyle.Office2003;
                    this.compareList2.Style = Windows.Forms.VisualStyle.Office2003;
                    this.compareList1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.compareList2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    break;
                case "Office2007Blue":
                case "Office2010Blue":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.button2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.comboBox1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.comboBox2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.radioButton1.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton2.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.radioButton2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    this.compareList1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.compareList2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Blue;
                    this.ColorScheme = Windows.Forms.Office2007Theme.Blue;
                    break;
                case "Office2007Black":
                case "Office2010Black":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Black;
                    this.button2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Black;
                    this.comboBox1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Black;
                    this.comboBox2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Black;
                    this.radioButton1.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton2.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Black;
                    this.radioButton2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Black;
                    this.compareList1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Black;
                    this.compareList2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Black;
                    this.ColorScheme = Windows.Forms.Office2007Theme.Black;
                    break;
                case "Office2007Silver":
                case "Office2010Silver":
                    this.button1.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button2.Appearance = Windows.Forms.ButtonAppearance.Office2007;
                    this.button1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Silver;
                    this.button2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Silver;
                    this.comboBox1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.comboBox1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Silver;
                    this.comboBox2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Silver;
                    this.radioButton1.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton2.Style = Windows.Forms.Tools.RadioButtonAdvStyle.Office2007;
                    this.radioButton1.Office2007ColorScheme = Windows.Forms.Office2007Theme.Silver;
                    this.radioButton2.Office2007ColorScheme = Windows.Forms.Office2007Theme.Silver;
                    this.compareList1.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList2.Style = Windows.Forms.VisualStyle.Office2007;
                    this.compareList1.Office2007ColorTheme = Windows.Forms.Office2007Theme.Silver;
                    this.compareList2.Office2007ColorTheme = Windows.Forms.Office2007Theme.Silver;
                    this.ColorScheme = Windows.Forms.Office2007Theme.Silver;
                    break;
            }
	
		}
		DataTable GetComboTable()
		{
			DataTable dt  =new DataTable();
			dt.Columns.Add("FilterString" );
            dt.Columns.Add("ValueString", typeof(FilterCompareOperator));
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterEqual), FilterCompareOperator.Equals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterNotequal), FilterCompareOperator.NotEquals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterGreaterthan), FilterCompareOperator.GreaterThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterGreaterthanOrEqual), FilterCompareOperator.GreaterThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterLessthan), FilterCompareOperator.LessThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterlessthanOrEqual), FilterCompareOperator.LessThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterLike), FilterCompareOperator.Like });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterMatch), FilterCompareOperator.Match });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterBeginsWith), 8 });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomComboboxAutoFilterEndsWith), 9 });
			dt.AcceptChanges(); 
			return dt;
		}
	}
}
