#region Copyright Syncfusion Inc. 2001 - 2009
// Copyright Syncfusion Inc. 2001 - 2009. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Data; 
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Grouping;

namespace Syncfusion.GridHelperClasses
{
	/// <summary>
	/// Summary description for CustomRowFilter.
	/// </summary>
	internal class CustomRowFilter : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.ComboBox comboBox2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CustomRowFilter()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            this.comboBox1.DataSource = GetComboTable();
            this.comboBox1.DisplayMember = "FilterString";
            this.comboBox1.ValueMember = "ValueString";
            this.comboBox2.DataSource = GetComboTable();
            this.comboBox2.DisplayMember = "FilterString";
            this.comboBox2.ValueMember = "ValueString";

            this.BackColor = Color.FromArgb(208, 215, 229);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.radioButton2 = new System.Windows.Forms.RadioButton();
            this.radioButton1 = new System.Windows.Forms.RadioButton();
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // comboBox1
            // 
            this.comboBox1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox1.Location = new System.Drawing.Point(24, 64);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(216, 21);
            this.comboBox1.TabIndex = 1;
            // 
            // textBox1
            // 
            this.textBox1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox1.Location = new System.Drawing.Point(264, 64);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(208, 22);
            this.textBox1.TabIndex = 0;
            // 
            // textBox2
            // 
            this.textBox2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox2.Location = new System.Drawing.Point(264, 136);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(208, 22);
            this.textBox2.TabIndex = 3;
            // 
            // comboBox2
            // 
            this.comboBox2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox2.Location = new System.Drawing.Point(24, 136);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(216, 21);
            this.comboBox2.TabIndex = 2;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.radioButton2);
            this.panel1.Controls.Add(this.radioButton1);
            this.panel1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.panel1.Location = new System.Drawing.Point(24, 96);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(216, 32);
            this.panel1.TabIndex = 4;
            // 
            // radioButton2
            // 
            this.radioButton2.Checked = true;
            this.radioButton2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton2.Location = new System.Drawing.Point(120, 8);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(48, 16);
            this.radioButton2.TabIndex = 1;
            this.radioButton2.TabStop = true;
            this.radioButton2.Text = SR.GetString(SR.Office2007FilterCustomFilteror);
            // 
            // radioButton1
            // 
            this.radioButton1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton1.Location = new System.Drawing.Point(56, 8);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(48, 16);
            this.radioButton1.TabIndex = 0;
            this.radioButton1.Text = SR.GetString(SR.Office2007FilterCustomFilterand);
            // 
            // button1
            // 
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button1.Font = new System.Drawing.Font("Segoe UI", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button1.Location = new System.Drawing.Point(304, 176);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(72, 24);
            this.button1.TabIndex = 5;
            this.button1.Text = SR.GetString(SR.CustomAutoFilterOK);
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.button2.Font = new System.Drawing.Font("Segoe UI", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button2.Location = new System.Drawing.Point(392, 176);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(72, 24);
            this.button2.TabIndex = 6;
            this.button2.Text = SR.GetString(SR.CustomAutoFilterCancel);
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(24, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(448, 16);
            this.label1.TabIndex = 7;
            this.label1.Text = SR.GetString(SR.showstherowswhere);
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(24, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(216, 16);
            this.label2.TabIndex = 8;
            // 
            // CustomRowFilter
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
            this.ClientSize = new System.Drawing.Size(490, 208);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.comboBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.comboBox1);
            this.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "CustomRowFilter";
            this.Text = SR.GetString(SR.CustomAutoFilter);
            this.Load += new System.EventHandler(this.CustomRowFilter_Load);
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
            if (this.comboBox1.Text.Length > 0 && this.textBox1.Text.Length > 0)
            {
                FilterString = '[' + mappingName + ']' + GetFilter(this.comboBox1.SelectedIndex, this.textBox1.Text);
            }
            if (this.comboBox2.Text.Length > 0 && this.textBox2.Text.Length > 0)
            {
                FilterString += (this.radioButton1.Checked) ? " AND " : " OR ";
                FilterString += '[' + mappingName + ']' + GetFilter(this.comboBox2.SelectedIndex, this.textBox2.Text);
            }
            this.DialogResult = DialogResult.OK;
            this.Close();
		}

        public void SetCombo(int index)
        {
            switch (index)
            {
                case 0:
                case 7:
                    this.comboBox1.SelectedIndex = 0;
                    break;
                case 1:
                    this.comboBox1.SelectedIndex = 1;
                    break;
                case 2:
                case 3:
                    this.comboBox1.SelectedIndex = 8;
                    break;
                case 4:
                    this.comboBox1.SelectedIndex = 9;
                    break;
                case 5:
                    this.comboBox1.SelectedIndex = 7;
                    break;                
            }            
            this.comboBox2.Text = String.Empty;
        }

        private string GetFilter(int index, string text)
        {
            string s = "";
            switch (index)
            {
                case 0:
                    s = " = '" + text + "'";
                    break;
                case 1:
                    s = " <> '" + text + "'";
                    break;
                case 2:
                    s = " > '" + text + "'";
                    break;
                case 3:
                    s = " >= '" + text + "'";
                    break;
                case 4:
                    s = " < '" + text + "'";
                    break;
                case 5:
                    s = " <= '" + text + "'";
                    break;
                case 6:
                    s = " like '" + text + "'";
                    break;
                case 7:
                    s = " like '*" + text + "*'";
                    break;
                case 8:
                    s = " like '" + text + "*'";
                    break;
                case 9:
                    s = " like '*" + text + "'";
                    break;
            }
            return s;
        }


		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		public string columnName = string.Empty;
        public string mappingName = String.Empty;
        public string FilterString = string.Empty;	
 
 
		private void CustomRowFilter_Load(object sender, System.EventArgs e)
		{            
			this.label2.Text = columnName;		
		}
		DataTable GetComboTable()
		{
			DataTable dt  =new DataTable();
			dt.Columns.Add("FilterString" );
			dt.Columns.Add("ValueString",typeof(FilterCompareOperator));  			
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterEqual), FilterCompareOperator.Equals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterNotequal), FilterCompareOperator.NotEquals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterGreaterthan), FilterCompareOperator.GreaterThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterGreaterthanOrEqual), FilterCompareOperator.GreaterThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterLessthan), FilterCompareOperator.LessThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterlessthanOrEqual), FilterCompareOperator.LessThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterLike), FilterCompareOperator.Like });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterMatch), FilterCompareOperator.Match });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterBeginsWith), 8 });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterEndsWith), 9 });
			dt.AcceptChanges(); 
			return dt;
		}
	}
}
