#region Copyright Syncfusion Inc. 2001 - 2009
// Copyright Syncfusion Inc. 2001 - 2009. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Data; 
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace Syncfusion.GridHelperClasses
{
	/// <summary>
	/// Summary description for CustomRowFilter.
	/// </summary>
	internal class MetroCustomRowFilter : MetroForm
	{
		private ComboBoxAdv comboBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
        private ComboBoxAdv comboBox2;
		private System.Windows.Forms.Panel panel1;
		private RadioButtonAdv radioButton1;
        private RadioButtonAdv radioButton2;
        public ButtonAdv button1;
        public ButtonAdv button2;
		private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private IContainer components;

        public MetroCustomRowFilter()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            this.comboBox1.DataSource = GetComboTable();
            this.comboBox1.DisplayMember = "FilterString";
            this.comboBox1.ValueMember = "ValueString";
            this.comboBox2.DataSource = GetComboTable();
            this.comboBox2.DisplayMember = "FilterString";
            this.comboBox2.ValueMember = "ValueString";

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.comboBox1 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.comboBox2 = new Syncfusion.Windows.Forms.Tools.ComboBoxAdv();
            this.panel1 = new System.Windows.Forms.Panel();
            this.radioButton2 = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.radioButton1 = new Syncfusion.Windows.Forms.Tools.RadioButtonAdv();
            this.button1 = new Syncfusion.Windows.Forms.ButtonAdv();
            this.button2 = new Syncfusion.Windows.Forms.ButtonAdv();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox2)).BeginInit();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton1)).BeginInit();
            this.SuspendLayout();
            // 
            // comboBox1
            // 
            this.comboBox1.BackColor = System.Drawing.Color.White;
            this.comboBox1.FlatBorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.comboBox1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox1.ForeColor = System.Drawing.Color.DimGray;
            this.comboBox1.Location = new System.Drawing.Point(24, 60);
            this.comboBox1.MetroColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(216, 21);
            this.comboBox1.Style = Syncfusion.Windows.Forms.VisualStyle.Metro;
            this.comboBox1.TabIndex = 1;
            // 
            // textBox1
            // 
            this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.textBox1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox1.ForeColor = System.Drawing.Color.DimGray;
            this.textBox1.Location = new System.Drawing.Point(264, 60);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(208, 22);
            this.textBox1.TabIndex = 0;
            // 
            // textBox2
            // 
            this.textBox2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.textBox2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox2.ForeColor = System.Drawing.Color.DimGray;
            this.textBox2.Location = new System.Drawing.Point(264, 120);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new System.Drawing.Size(208, 22);
            this.textBox2.TabIndex = 3;
            // 
            // comboBox2
            // 
            this.comboBox2.BackColor = System.Drawing.Color.White;
            this.comboBox2.FlatBorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.comboBox2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.comboBox2.ForeColor = System.Drawing.Color.DimGray;
            this.comboBox2.Location = new System.Drawing.Point(24, 120);
            this.comboBox2.MetroColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(216, 21);
            this.comboBox2.Style = Syncfusion.Windows.Forms.VisualStyle.Metro;
            this.comboBox2.TabIndex = 2;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.radioButton2);
            this.panel1.Controls.Add(this.radioButton1);
            this.panel1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.panel1.Location = new System.Drawing.Point(24, 84);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(216, 32);
            this.panel1.TabIndex = 4;
            // 
            // radioButton2
            // 
            this.radioButton2.Checked = true;
            this.radioButton2.DrawFocusRectangle = false;
            this.radioButton2.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton2.ForeColor = System.Drawing.Color.DimGray;
            this.radioButton2.Location = new System.Drawing.Point(120, 8);
            this.radioButton2.MetroColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(48, 16);
            this.radioButton2.Style = Syncfusion.Windows.Forms.Tools.RadioButtonAdvStyle.Metro;
            this.radioButton2.TabIndex = 1;
            this.radioButton2.ThemesEnabled = false;
            this.radioButton2.Text = SR.GetString(SR.Office2007FilterCustomFilteror);
            // 
            // radioButton1
            // 
            this.radioButton1.DrawFocusRectangle = false;
            this.radioButton1.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.radioButton1.ForeColor = System.Drawing.Color.DimGray;
            this.radioButton1.Location = new System.Drawing.Point(56, 8);
            this.radioButton1.MetroColor = System.Drawing.Color.FromArgb(((int)(((byte)(27)))), ((int)(((byte)(161)))), ((int)(((byte)(226)))));
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(48, 16);
            this.radioButton1.Style = Syncfusion.Windows.Forms.Tools.RadioButtonAdvStyle.Metro;
            this.radioButton1.TabIndex = 0;
            this.radioButton1.ThemesEnabled = false;
            this.radioButton1.Text = SR.GetString(SR.Office2007FilterCustomFilterand);
            // 
            // button1
            // 
            this.button1.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.Metro;
            this.button1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(253)))), ((int)(((byte)(143)))), ((int)(((byte)(0)))));
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.button1.Font = new System.Drawing.Font("Segoe UI Semibold", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button1.ForeColor = System.Drawing.Color.White;
            this.button1.Location = new System.Drawing.Point(304, 159);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(72, 26);
            this.button1.TabIndex = 5;
            this.button1.UseVisualStyle = true;
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Text = SR.GetString(SR.CustomAutoFilterOK);
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.Metro;
            this.button2.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(253)))), ((int)(((byte)(143)))), ((int)(((byte)(0)))));
            this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.button2.Font = new System.Drawing.Font("Segoe UI Semibold", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.button2.ForeColor = System.Drawing.Color.White;
            this.button2.Location = new System.Drawing.Point(392, 159);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(80, 26);
            this.button2.TabIndex = 6;
            this.button2.UseVisualStyle = true;
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Text = SR.GetString(SR.CustomAutoFilterCancel);
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Segoe UI Semibold", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.ForeColor = System.Drawing.Color.DimGray;
            this.label1.Location = new System.Drawing.Point(24, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(448, 16);
            this.label1.TabIndex = 7;
            this.label1.Text = SR.GetString(SR.showstherowswhere);
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Segoe UI Semibold", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.ForeColor = System.Drawing.Color.DimGray;
            this.label2.Location = new System.Drawing.Point(24, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(216, 16);
            this.label2.TabIndex = 8;
            // 
            // MetroCustomRowFilter
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
            this.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(42)))), ((int)(((byte)(191)))), ((int)(((byte)(241)))));
            this.BorderThickness = 2;
            this.CaptionBarColor = System.Drawing.Color.FromArgb(((int)(((byte)(42)))), ((int)(((byte)(191)))), ((int)(((byte)(241)))));
            this.CaptionButtonColor = System.Drawing.Color.White;
            this.CaptionFont = new System.Drawing.Font("Segoe UI Semibold", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.CaptionForeColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(490, 190);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.comboBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.comboBox1);
            this.DropShadow = true;
            this.Font = new System.Drawing.Font("Segoe UI", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MetroColor = System.Drawing.Color.FromArgb(((int)(((byte)(42)))), ((int)(((byte)(191)))), ((int)(((byte)(241)))));
            this.MinimizeBox = false;
            this.Name = "MetroCustomRowFilter";
            this.Text = SR.GetString(SR.CustomAutoFilter);
            this.ShowIcon = false;
            this.Load += new System.EventHandler(this.CustomRowFilter_Load);
            ((System.ComponentModel.ISupportInitialize)(this.comboBox1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.comboBox2)).EndInit();
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.radioButton2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.radioButton1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
            if (this.comboBox1.Text.Length > 0 && this.textBox1.Text.Length > 0)
            {
                FilterString = '[' + mappingName + ']' + GetFilter(this.comboBox1.SelectedIndex, this.textBox1.Text);
            }
            if (this.comboBox2.Text.Length > 0 && this.textBox2.Text.Length > 0)
            {
                FilterString += (this.radioButton1.Checked) ? " AND " : " OR ";
                FilterString += '[' + mappingName + ']' + GetFilter(this.comboBox2.SelectedIndex, this.textBox2.Text);
            }
            this.DialogResult = DialogResult.OK;
            this.Close();
		}

        public void SetCombo(int index)
        {
            switch (index)
            {
                case 0:
                case 7:
                    this.comboBox1.SelectedIndex = 0;
                    break;
                case 1:
                    this.comboBox1.SelectedIndex = 1;
                    break;
                case 2:
                case 3:
                    this.comboBox1.SelectedIndex = 8;
                    break;
                case 4:
                    this.comboBox1.SelectedIndex = 9;
                    break;
                case 5:
                    this.comboBox1.SelectedIndex = 7;
                    break;                
            }            
            this.comboBox2.Text = String.Empty;
        }

        private string GetFilter(int index, string text)
        {
            string s = "";
            switch (index)
            {
                case 0:
                    s = " = '" + text + "'";
                    break;
                case 1:
                    s = " <> '" + text + "'";
                    break;
                case 2:
                    s = " > '" + text + "'";
                    break;
                case 3:
                    s = " >= '" + text + "'";
                    break;
                case 4:
                    s = " < '" + text + "'";
                    break;
                case 5:
                    s = " <= '" + text + "'";
                    break;
                case 6:
                    s = " like '" + text + "'";
                    break;
                case 7:
                    s = " like '*" + text + "*'";
                    break;
                case 8:
                    s = " like '" + text + "*'";
                    break;
                case 9:
                    s = " like '*" + text + "'";
                    break;
            }
            return s;
        }


		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		public string columnName = string.Empty;
        public string mappingName = String.Empty;
        public string FilterString = string.Empty;	
 
 
		private void CustomRowFilter_Load(object sender, System.EventArgs e)
		{            
			this.label2.Text = columnName;		
		}
		DataTable GetComboTable()
		{
			DataTable dt  =new DataTable();
			dt.Columns.Add("FilterString" );
			dt.Columns.Add("ValueString",typeof(FilterCompareOperator));  			
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterEqual), FilterCompareOperator.Equals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterNotequal), FilterCompareOperator.NotEquals });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterGreaterthan), FilterCompareOperator.GreaterThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterGreaterthanOrEqual), FilterCompareOperator.GreaterThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterLessthan), FilterCompareOperator.LessThan });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterlessthanOrEqual), FilterCompareOperator.LessThanOrEqualTo });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterLike), FilterCompareOperator.Like });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterMatch), FilterCompareOperator.Match });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterBeginsWith), 8 });
            dt.Rows.Add(new object[] { SR.GetString(SR.CustomAutoFilterEndsWith), 9 });
			dt.AcceptChanges(); 
			return dt;
		}
	}
}
